/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Histogram.xs. Do not edit this file, edit Histogram.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Histogram.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "assert.h"
#include "ppport.h"

#include "perl_type_tools.h"

#include "mh_histogram.h"

#define ASSERT_BIN_RANGE(axis, ibin) \
    STMT_START { \
      if (ibin < 1 || ibin > MH_AXIS_NBINS(axis)) \
        croak("Bin %u outside axis bin range (min: 1, max: %u)", MH_AXIS_NBINS(axis)); \
    } STMT_END

#define ASSERT_BIN_RANGE_WITH_OVERFLOW(axis, ibin) \
    STMT_START { \
      if (ibin < 0 || ibin > MH_AXIS_NBINS(axis)+1) \
        croak("Bin %u outside axis bin range (incl. under- and overflow: min: 0, max: %u)", MH_AXIS_NBINS(axis)+1); \
    } STMT_END


/* The following are flags that we use on the userdata slot of an axis.
 * Right now, that's just using the first bit (take care not to use more than 32...)
 * indicating that if set, the axis is owned by a histogram. If that's the case,
 * using that axis in another histogram will create a clone of the axis.
 * At the same time, any explicit Perl-level reference to the axis will not free
 * the underlying C object if that bit is set as the Perl-level reference goes out of
 * scope. */
#define F_AXIS_OWNED_BY_HIST 1

static SV *
axis_to_hashref(pTHX_ mh_axis_t *axis)
{
  SV *rv;
  HV *hash;
  hash = newHV();

  if (MH_AXIS_ISFIXBIN(axis)) {
    if ( ! hv_stores(hash, "nbins", newSVuv(MH_AXIS_NBINS(axis))) )
      croak("hv_stores nbins failed");
    if ( ! hv_stores(hash, "min", newSVnv(MH_AXIS_MIN(axis))) )
      croak("hv_stores min failed");
    if ( ! hv_stores(hash, "max", newSVnv(MH_AXIS_MAX(axis))) )
      croak("hv_stores max failed");
  }
  else {
    unsigned int i, n;
    AV *bin_av;
    double *bins = axis->bins;
    n = MH_AXIS_NBINS(axis);
    bin_av = newAV();
    if ( ! hv_stores(hash, "bins", newRV_noinc((SV *)bin_av)) )
      croak("hv_stores bins failed");
    av_extend(bin_av, n);
    for (i = 0; i <= n; ++i)
      av_store(bin_av, i, newSVnv(bins[i]));
  }
  rv = newRV_noinc((SV *)hash);

  return rv;
}

static mh_axis_t *
hash_to_axis(pTHX_ HV *hash)
{
  unsigned int nbins;
  SV *tmp;
  SV **svptr;
  mh_axis_t *rv;

  if (hv_exists(hash, "bins", 4)) { /* varbins */
    AV *bin_av;
    tmp = *hv_fetchs(hash, "bins", 0);
    DEREF_RV_TO_AV(bin_av, tmp);
    if (bin_av == NULL)
      croak("'bins' entry is not an array reference");
    nbins = av_len(bin_av);
    rv = mh_axis_create( nbins, MH_AXIS_OPT_VARBINS );
    if (rv == NULL)
      croak("Cannot create Math::Histogram::Axis! Invalid number of bins or out of memory.");
    av_to_double_ary(aTHX_ bin_av, rv->bins);
    /* FIXME include same bin order sanity check as for the normal constructor? */
    mh_axis_init( rv, rv->bins[0], rv->bins[nbins] );
  }
  else { /* fixed width bins */
    double min, max;
    svptr = hv_fetchs(hash, "nbins", 0);
    if (svptr == NULL)
      croak("Missing 'bins' and 'nbins' hash entries");
    nbins = SvUV(*svptr);
    svptr = hv_fetchs(hash, "min", 0);
    if (svptr == NULL)
      croak("Missing 'min' hash entry");
    min = SvNV(*svptr);
    svptr = hv_fetchs(hash, "max", 0);
    if (svptr == NULL)
      croak("Missing 'max' hash entry");
    max = SvNV(*svptr);
    if (min > max) {
      double tmp = min;
      min = max;
      max = tmp;
    }
    rv = mh_axis_create( nbins, MH_AXIS_OPT_FIXEDBINS );
    if (rv == NULL)
      croak("Cannot create Math::Histogram::Axis! Invalid bin number or out of memory.");
    mh_axis_init( rv, min, max );
  }

  return rv;
}

/*
 * FIXME This file has a bunch of hardcoded class names for non-constructor methods
 *       that return objects. That needs to be fixed!
 */

#line 132 "Histogram.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 276 "Histogram.c"

/* INCLUDE:  Including 'XS/Axis.xs' from 'Histogram.xs' */


XS_EUPXS(XS_Math__Histogram__Axis_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "CLASS, ...");
    {
#line 7 "./XS/Axis.xs"
    SV *tmp;
    AV *bins;
    I32 n, i;
    double prev;
    double *dbl_ary;
#line 294 "Histogram.c"
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	mh_axis_t *	RETVAL;
#line 13 "./XS/Axis.xs"
    /* varbins => just a single arrayref */
    if (items == 2) {
      tmp = ST(1);
      DEREF_RV_TO_AV(bins, tmp);
      if (bins == NULL)
        croak("Need either array reference as first parameter or a number of bins followed by min/max");
      n = av_len(bins) + 1;
      if (n <= 1)
        croak("Bins array must have at least a lower and upper boundary for a single bin");

      RETVAL = mh_axis_create( n-1, MH_AXIS_OPT_VARBINS );
      if (RETVAL == NULL)
        croak("Cannot create Math::Histogram::Axis! Invalid number of bins or out of memory.");

      av_to_double_ary(aTHX_ bins, RETVAL->bins);

      /* Check whether the numbers make some basic sense */
      dbl_ary = RETVAL->bins;
      prev = dbl_ary[0];
      for (i = 1; i < n; ++i) {
        if (dbl_ary[i] <= prev) {
          mh_axis_free(RETVAL);
          croak("Bin boundaries for histogram axis are not strictly monotonic!");
        }
        prev = dbl_ary[i];
      }
      mh_axis_init( RETVAL, RETVAL->bins[0], RETVAL->bins[n-1] );
    }
    /* fixbins => n, min, max */
    else if (items == 4) {
      RETVAL = mh_axis_create( SvUV(ST(1)), MH_AXIS_OPT_FIXEDBINS );
      if (RETVAL == NULL)
        croak("Cannot create Math::Histogram::Axis! Invalid number of bins or out of memory.");
      prev = SvNV(ST(2));
      if (prev >= SvNV(ST(3))) {
        mh_axis_free(RETVAL);
        croak("Lower axis boundary (%f) cannot be larger than or equal to upper boundary (%f)!", prev, SvNV(ST(3)));
      }
      mh_axis_init( RETVAL, prev, SvNV(ST(3)) );
    }
#line 339 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_axis_t *	THIS;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::DESTROY() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 59 "./XS/Axis.xs"
    /* free only if not owned by some histogram */
    if (!( PTR2UV(MH_AXIS_USERDATA(THIS)) & F_AXIS_OWNED_BY_HIST ))
      mh_axis_free(THIS);
#line 371 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram__Axis__as_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis__as_hash)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 67 "./XS/Axis.xs"
    SV *rv;
#line 388 "Histogram.c"
	mh_axis_t *	THIS;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::_as_hash() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 69 "./XS/Axis.xs"
    rv = sv_2mortal(axis_to_hashref(aTHX_ THIS));
    XPUSHs(rv);
    XSRETURN(1);
#line 402 "Histogram.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Histogram__Axis__from_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis__from_hash)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, hash");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	HV *	hash;
	mh_axis_t *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    hash = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Math::Histogram::Axis::_from_hash",
				"hash");
		}
	} STMT_END
;
#line 79 "./XS/Axis.xs"
    RETVAL = hash_to_axis(aTHX_ hash);
#line 436 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
#line 86 "./XS/Axis.xs"
    const char *CLASS = "Math::Histogram::Axis"; /* hack around deficient typemap */
#line 457 "Histogram.c"
	mh_axis_t *	THIS;
	mh_axis_t *	RETVAL;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::clone() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 88 "./XS/Axis.xs"
    RETVAL = mh_axis_clone(THIS);
#line 470 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_nbins); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_nbins)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_axis_t *	THIS;
	unsigned int	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::nbins() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 95 "./XS/Axis.xs"
    RETVAL = MH_AXIS_NBINS(THIS);
#line 502 "Histogram.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_min)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_axis_t *	THIS;
	double	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::min() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 102 "./XS/Axis.xs"
    RETVAL = MH_AXIS_MIN(THIS);
#line 530 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_max)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_axis_t *	THIS;
	double	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::max() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 109 "./XS/Axis.xs"
    RETVAL = MH_AXIS_MAX(THIS);
#line 558 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_width); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_width)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_axis_t *	THIS;
	double	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::width() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 116 "./XS/Axis.xs"
    RETVAL = MH_AXIS_WIDTH(THIS);
#line 586 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_binsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_binsize)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, ibin= 1");
    {
	mh_axis_t *	THIS;
	double	RETVAL;
	dXSTARG;
	unsigned int	ibin;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::binsize() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;

	if (items < 2)
	    ibin = 1;
	else {
	    ibin = (unsigned int)SvUV(ST(1))
;
	}
#line 124 "./XS/Axis.xs"
    ASSERT_BIN_RANGE(THIS, ibin);
    RETVAL = MH_AXIS_BINSIZE(THIS, ibin);
#line 623 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_lower_boundary); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_lower_boundary)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, ibin= 1");
    {
	mh_axis_t *	THIS;
	double	RETVAL;
	dXSTARG;
	unsigned int	ibin;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::lower_boundary() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;

	if (items < 2)
	    ibin = 1;
	else {
	    ibin = (unsigned int)SvUV(ST(1))
;
	}
#line 132 "./XS/Axis.xs"
    ASSERT_BIN_RANGE(THIS, ibin);
    RETVAL = MH_AXIS_BIN_LOWER(THIS, ibin);
#line 660 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_upper_boundary); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_upper_boundary)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, ibin= 1");
    {
	mh_axis_t *	THIS;
	double	RETVAL;
	dXSTARG;
	unsigned int	ibin;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::upper_boundary() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;

	if (items < 2)
	    ibin = 1;
	else {
	    ibin = (unsigned int)SvUV(ST(1))
;
	}
#line 140 "./XS/Axis.xs"
    ASSERT_BIN_RANGE(THIS, ibin);
    RETVAL = MH_AXIS_BIN_UPPER(THIS, ibin);
#line 697 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_bin_center); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_bin_center)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "THIS, ibin= 1");
    {
	mh_axis_t *	THIS;
	double	RETVAL;
	dXSTARG;
	unsigned int	ibin;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::bin_center() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;

	if (items < 2)
	    ibin = 1;
	else {
	    ibin = (unsigned int)SvUV(ST(1))
;
	}
#line 148 "./XS/Axis.xs"
    ASSERT_BIN_RANGE(THIS, ibin);
    RETVAL = MH_AXIS_BIN_CENTER(THIS, ibin);
#line 734 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__Axis_find_bin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__Axis_find_bin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, x");
    {
	mh_axis_t *	THIS;
	unsigned int	RETVAL;
	dXSTARG;
	double	x = (double)SvNV(ST(1))
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_axis_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::Axis::find_bin() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 156 "./XS/Axis.xs"
    RETVAL = mh_axis_find_bin(THIS, x);
#line 764 "Histogram.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'Histogram.xs' from 'XS/Axis.xs' */


/* INCLUDE:  Including 'XS/Histogram.xs' from 'Histogram.xs' */


XS_EUPXS(XS_Math__Histogram_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, axises");
    {
#line 7 "./XS/Histogram.xs"
    mh_axis_t **axis_structs;
    mh_axis_t *tmp_axis;
    unsigned int i, n;
#line 789 "Histogram.c"
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	mh_histogram_t *	RETVAL;
	AV *	axises;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    axises = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::new",
				"axises");
		}
	} STMT_END
;
#line 11 "./XS/Histogram.xs"
    n = av_len(axises)+1;
    if (n == 0)
      croak("Need array reference of axis objetcs");
    axis_structs = av_to_axis_ary(aTHX_ axises, n);
    if (axis_structs == NULL)
      croak("Need array reference of axis objetcs");

    for (i = 0; i < n; ++i) {
      tmp_axis = axis_structs[i];
      /* Clone axis if owned by histogram, otherwise set the "ownership" bit */
      if (PTR2UV(MH_AXIS_USERDATA(tmp_axis)) & F_AXIS_OWNED_BY_HIST)
        axis_structs[i] = mh_axis_clone(tmp_axis);
      else {
        UV flags = PTR2UV(MH_AXIS_USERDATA(tmp_axis));
        flags |= F_AXIS_OWNED_BY_HIST;
        MH_AXIS_USERDATA(tmp_axis) = INT2PTR(void *, flags);
      }
    }

    RETVAL = mh_hist_create(n, axis_structs);
#line 829 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_histogram_t *	THIS;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::DESTROY() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 37 "./XS/Histogram.xs"
    mh_hist_free(THIS);
#line 859 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
#line 43 "./XS/Histogram.xs"
    const char *CLASS = "Math::Histogram";
#line 874 "Histogram.c"
	mh_histogram_t *	THIS;
	mh_histogram_t *	RETVAL;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::clone() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 45 "./XS/Histogram.xs"
    RETVAL = mh_hist_clone(THIS, 1); /* 1 => do clone data */
#line 887 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_new_alike); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_new_alike)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
#line 52 "./XS/Histogram.xs"
    const char *CLASS = "Math::Histogram";
#line 908 "Histogram.c"
	mh_histogram_t *	THIS;
	mh_histogram_t *	RETVAL;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::new_alike() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 54 "./XS/Histogram.xs"
    RETVAL = mh_hist_clone(THIS, 0); /* 0 => do NOT clone data */
#line 921 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_get_axis); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_get_axis)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, dimension");
    {
#line 61 "./XS/Histogram.xs"
    const char *CLASS = "Math::Histogram::Axis";
#line 942 "Histogram.c"
	mh_histogram_t *	THIS;
	mh_axis_t *	RETVAL;
	unsigned int	dimension = (unsigned int)SvUV(ST(1))
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::get_axis() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 63 "./XS/Histogram.xs"
    if (dimension >= MH_HIST_NDIM(THIS))
      croak("Dimension number out of bounds: %u", dimension);
    RETVAL = MH_HIST_AXIS(THIS, dimension);
#line 959 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_ndim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_ndim)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_histogram_t *	THIS;
	unsigned int	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::ndim() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 72 "./XS/Histogram.xs"
    RETVAL = MH_HIST_NDIM(THIS);
#line 991 "Histogram.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_nfills); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_nfills)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_histogram_t *	THIS;
	unsigned int	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::nfills() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 79 "./XS/Histogram.xs"
    RETVAL = MH_HIST_NFILLS(THIS);
#line 1019 "Histogram.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_total); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_total)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_histogram_t *	THIS;
	double	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::total() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 86 "./XS/Histogram.xs"
    RETVAL = MH_HIST_TOTAL(THIS);
#line 1047 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_find_bin_numbers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_find_bin_numbers)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, coords");
    {
	AV *	coords;
	mh_histogram_t *	THIS;
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    coords = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::find_bin_numbers",
				"coords");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::find_bin_numbers() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 94 "./XS/Histogram.xs"
    av_to_double_ary(aTHX_ coords, MH_HIST_ARG_COORD_BUFFER(THIS));
    mh_hist_find_bin_numbers(THIS, MH_HIST_ARG_COORD_BUFFER(THIS), MH_HIST_ARG_BIN_BUFFER(THIS));
    unsigned_int_ary_to_av(aTHX_ MH_HIST_NDIM(THIS), MH_HIST_ARG_BIN_BUFFER(THIS), &RETVAL);
    sv_2mortal((SV*)RETVAL);
#line 1092 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_fill); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_fill)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, coords");
    {
	AV *	coords;
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    coords = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill",
				"coords");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::fill() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 105 "./XS/Histogram.xs"
    av_to_double_ary(aTHX_ coords, MH_HIST_ARG_COORD_BUFFER(THIS));
    mh_hist_fill(THIS, MH_HIST_ARG_COORD_BUFFER(THIS));
#line 1138 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_fill_w); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_fill_w)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, coords, weight");
    {
	AV *	coords;
	double	weight = (double)SvNV(ST(2))
;
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    coords = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_w",
				"coords");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::fill_w() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 114 "./XS/Histogram.xs"
    av_to_double_ary(aTHX_ coords, MH_HIST_ARG_COORD_BUFFER(THIS));
    mh_hist_fill_w(THIS, MH_HIST_ARG_COORD_BUFFER(THIS), weight);
#line 1180 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_fill_n); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_fill_n)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, coords");
    {
	AV *	coords;
#line 122 "./XS/Histogram.xs"
    SV **elem;
    SV *sv;
    unsigned int i, n;
#line 1198 "Histogram.c"
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    coords = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_n",
				"coords");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::fill_n() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 126 "./XS/Histogram.xs"
    n = av_len(coords)+1;
    /* Fill each individually since we have
     * to do lots of Perl => C conversion anyway */
    for (i = 0; i < n; ++i) {
      elem = av_fetch(coords, i, 0);
      if (elem == NULL)
        croak("Woah, this should never happen!");

      /* Inner array deref */
      sv = *elem;
      SvGETMAGIC(sv);
      if (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV) {
        av_to_double_ary(aTHX_ (AV*)SvRV(sv), MH_HIST_ARG_COORD_BUFFER(THIS));
        mh_hist_fill(THIS, MH_HIST_ARG_COORD_BUFFER(THIS));
      }
      else
        croak("Element with index %u of input array reference is "
              "not an array reference, stopping histogram filling "
              "at that point!", i);
    }
#line 1243 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_fill_nw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_fill_nw)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, coords, weights");
    {
	AV *	coords;
	AV *	weights;
#line 153 "./XS/Histogram.xs"
    SV **elem;
    SV *sv;
    unsigned int i, n;
    double weight;
#line 1263 "Histogram.c"
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    coords = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_nw",
				"coords");
		}
	} STMT_END
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    weights = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_nw",
				"weights");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::fill_nw() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 158 "./XS/Histogram.xs"
    n = av_len(coords)+1;
    if ((unsigned int)(av_len(weights)+1) != n)
      croak("Coordinates and weights arrays need to be of same size!");

    /* Fill each individually since we have
     * to do lots of Perl => C conversion anyway */
    for (i = 0; i < n; ++i) {
      elem = av_fetch(weights, i, 0);
      if (elem == NULL)
        croak("Woah, this should never happen!");
      weight = SvNV(*elem);

      elem = av_fetch(coords, i, 0);
      if (elem == NULL)
        croak("Woah, this should never happen!");

      /* Inner array deref */
      sv = *elem;
      SvGETMAGIC(sv);
      if (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV) {
        av_to_double_ary(aTHX_ (AV*)SvRV(sv), MH_HIST_ARG_COORD_BUFFER(THIS));
        mh_hist_fill_w(THIS, MH_HIST_ARG_COORD_BUFFER(THIS), weight);
      }
      else
        croak("Element with index %u of input array reference is "
              "not an array reference, stopping histogram filling "
              "at that point!", i);
    }
#line 1330 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_fill_bin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_fill_bin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, dim_bin_nums");
    {
	AV *	dim_bin_nums;
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    dim_bin_nums = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_bin",
				"dim_bin_nums");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::fill_bin() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 192 "./XS/Histogram.xs"
    av_to_unsigned_int_ary(aTHX_ dim_bin_nums, MH_HIST_ARG_BIN_BUFFER(THIS));
    mh_hist_fill_bin(THIS, MH_HIST_ARG_BIN_BUFFER(THIS));
#line 1370 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_fill_bin_w); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_fill_bin_w)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, dim_bin_nums, weight");
    {
	AV *	dim_bin_nums;
	double	weight = (double)SvNV(ST(2))
;
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    dim_bin_nums = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_bin_w",
				"dim_bin_nums");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::fill_bin_w() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 201 "./XS/Histogram.xs"
    av_to_unsigned_int_ary(aTHX_ dim_bin_nums, MH_HIST_ARG_BIN_BUFFER(THIS));
    mh_hist_fill_bin_w(THIS, MH_HIST_ARG_BIN_BUFFER(THIS), weight);
#line 1412 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_fill_bin_n); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_fill_bin_n)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, dim_bin_nums");
    {
	AV *	dim_bin_nums;
#line 209 "./XS/Histogram.xs"
    SV **elem;
    SV *sv;
    unsigned int i, n;
#line 1430 "Histogram.c"
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    dim_bin_nums = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_bin_n",
				"dim_bin_nums");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::fill_bin_n() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 213 "./XS/Histogram.xs"
    n = av_len(dim_bin_nums)+1;
    /* Fill each individually since we have
     * to do lots of Perl => C conversion anyway */
    for (i = 0; i < n; ++i) {
      elem = av_fetch(dim_bin_nums, i, 0);
      if (elem == NULL)
        croak("Woah, this should never happen!");

      /* Inner array deref */
      sv = *elem;
      SvGETMAGIC(sv);
      if (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV) {
        av_to_unsigned_int_ary(aTHX_ (AV*)SvRV(sv), MH_HIST_ARG_BIN_BUFFER(THIS));
        mh_hist_fill_bin(THIS, MH_HIST_ARG_BIN_BUFFER(THIS));
      }
      else
        croak("Element with index %u of input array reference is "
              "not an array reference, stopping histogram filling "
              "at that point!", i);
    }
#line 1475 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_fill_bin_nw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_fill_bin_nw)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, dim_bin_nums, weights");
    {
	AV *	dim_bin_nums;
	AV *	weights;
#line 240 "./XS/Histogram.xs"
    SV **elem;
    SV *sv;
    unsigned int i, n;
    double weight;
#line 1495 "Histogram.c"
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    dim_bin_nums = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_bin_nw",
				"dim_bin_nums");
		}
	} STMT_END
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    weights = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::fill_bin_nw",
				"weights");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::fill_bin_nw() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 245 "./XS/Histogram.xs"
    n = av_len(dim_bin_nums)+1;
    if ((unsigned int)(av_len(weights)+1) != n)
      croak("Bin-numbers and weights arrays need to be of same size!");

    /* Fill each individually since we have
     * to do lots of Perl => C conversion anyway */
    for (i = 0; i < n; ++i) {
      elem = av_fetch(weights, i, 0);
      if (elem == NULL)
        croak("Woah, this should never happen!");
      weight = SvNV(*elem);

      elem = av_fetch(dim_bin_nums, i, 0);
      if (elem == NULL)
        croak("Woah, this should never happen!");

      /* Inner array deref */
      sv = *elem;
      SvGETMAGIC(sv);
      if (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV) {
        av_to_unsigned_int_ary(aTHX_ (AV*)SvRV(sv), MH_HIST_ARG_BIN_BUFFER(THIS));
        mh_hist_fill_bin_w(THIS, MH_HIST_ARG_BIN_BUFFER(THIS), weight);
      }
      else
        croak("Element with index %u of input array reference is "
              "not an array reference, stopping histogram filling "
              "at that point!", i);
    }
#line 1562 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_get_bin_content); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_get_bin_content)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, dim_bin_nums");
    {
	AV *	dim_bin_nums;
#line 279 "./XS/Histogram.xs"
    int rc;
#line 1578 "Histogram.c"
	mh_histogram_t *	THIS;
	double	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    dim_bin_nums = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::get_bin_content",
				"dim_bin_nums");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::get_bin_content() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 281 "./XS/Histogram.xs"
    av_to_unsigned_int_ary(aTHX_ dim_bin_nums, MH_HIST_ARG_BIN_BUFFER(THIS));
    rc = mh_hist_get_bin_content(THIS, MH_HIST_ARG_BIN_BUFFER(THIS), &RETVAL);
    if (rc != 0)
      croak("Bin numbers out of range!");
#line 1609 "Histogram.c"
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_set_bin_content); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_set_bin_content)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, dim_bin_nums, content");
    {
	AV *	dim_bin_nums;
	double	content = (double)SvNV(ST(2))
;
#line 293 "./XS/Histogram.xs"
    int rc;
#line 1629 "Histogram.c"
	mh_histogram_t *	THIS;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    dim_bin_nums = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::set_bin_content",
				"dim_bin_nums");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::set_bin_content() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 295 "./XS/Histogram.xs"
    av_to_unsigned_int_ary(aTHX_ dim_bin_nums, MH_HIST_ARG_BIN_BUFFER(THIS));
    rc = mh_hist_set_bin_content(THIS, MH_HIST_ARG_BIN_BUFFER(THIS), content);
    if (rc != 0)
      croak("Bin numbers out of range!");
#line 1658 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_contract_dimension); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_contract_dimension)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, contracted_dimension");
    {
	unsigned int	contracted_dimension = (unsigned int)SvUV(ST(1))
;
#line 305 "./XS/Histogram.xs"
    const char *CLASS = "Math::Histogram"; /* FIXME */
#line 1675 "Histogram.c"
	mh_histogram_t *	THIS;
	mh_histogram_t *	RETVAL;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::contract_dimension() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 307 "./XS/Histogram.xs"
    RETVAL = mh_hist_contract_dimension(THIS, contracted_dimension);
    if (RETVAL == NULL)
      croak("Contracted dimension appears to be out of range!");
#line 1690 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_cumulate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_cumulate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, cumulation_dimension");
    {
	unsigned int	cumulation_dimension = (unsigned int)SvUV(ST(1))
;
#line 317 "./XS/Histogram.xs"
    int rc;
#line 1713 "Histogram.c"
	mh_histogram_t *	THIS;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::cumulate() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 319 "./XS/Histogram.xs"
    rc = mh_hist_cumulate(THIS, cumulation_dimension);
    if (rc != 0)
      croak("Cumulated dimension appears to be out of range!");
#line 1727 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram_data_equal_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_data_equal_to)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, other");
    {
	mh_histogram_t *	other;
	mh_histogram_t *	THIS;
	int	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
                other = (mh_histogram_t *)SvIV((SV*)SvRV( ST(1) ));
        else{
                warn( "Math::Histogram::data_equal_to() -- other is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::data_equal_to() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 327 "./XS/Histogram.xs"
    RETVAL = mh_hist_data_equal(THIS, other);
#line 1762 "Histogram.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_is_overflow_bin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_is_overflow_bin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, dim_bin_nums");
    {
	AV *	dim_bin_nums;
	mh_histogram_t *	THIS;
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    dim_bin_nums = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::is_overflow_bin",
				"dim_bin_nums");
		}
	} STMT_END
;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::is_overflow_bin() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 335 "./XS/Histogram.xs"
    av_to_unsigned_int_ary(aTHX_ dim_bin_nums, MH_HIST_ARG_BIN_BUFFER(THIS));
    RETVAL = !!mh_hist_is_overflow_bin(THIS, MH_HIST_ARG_BIN_BUFFER(THIS));
#line 1806 "Histogram.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram_is_overflow_bin_linear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram_is_overflow_bin_linear)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "THIS, linear_bin_num");
    {
	unsigned int	linear_bin_num = (unsigned int)SvUV(ST(1))
;
	mh_histogram_t *	THIS;
	int	RETVAL;
	dXSTARG;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::is_overflow_bin_linear() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 343 "./XS/Histogram.xs"
    RETVAL = !!mh_hist_is_overflow_bin_linear(THIS, linear_bin_num);
#line 1836 "Histogram.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Histogram__debug_bin_iter_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__debug_bin_iter_print)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_histogram_t *	THIS;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::_debug_bin_iter_print() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 349 "./XS/Histogram.xs"
    mh_hist_debug_bin_iter_print(THIS);
#line 1862 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram__debug_dump_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__debug_dump_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	mh_histogram_t *	THIS;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::_debug_dump_data() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 354 "./XS/Histogram.xs"
    mh_hist_debug_dump_data(THIS);
#line 1886 "Histogram.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__Histogram__as_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__as_hash)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 359 "./XS/Histogram.xs"
    SV *rv;
    SV *tmp;
    HV *hash;
    AV *axis_av;
    AV *data_av;
    unsigned int ndim, i, nbins_total;
    double *data;
    mh_axis_t *tmp_axis;
#line 1910 "Histogram.c"
	mh_histogram_t *	THIS;

        if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
                THIS = (mh_histogram_t *)SvIV((SV*)SvRV( ST(0) ));
        else{
                warn( "Math::Histogram::_as_hash() -- THIS is not a blessed SV reference" );
                XSRETURN_UNDEF;
        }
;
#line 368 "./XS/Histogram.xs"
    hash = newHV();
    rv = sv_2mortal(newRV_noinc((SV *)hash));

    ndim = MH_HIST_NDIM(THIS);
    if ( ! hv_stores(hash, "ndim", newSVuv(ndim)) )
      croak("hv_stores ndim failed");

    /* store axises */
    axis_av = newAV();
    if ( ! hv_stores(hash, "axises", newRV_noinc((SV *)axis_av)) )
      croak("hv_stores ndim failed");
    av_extend(axis_av, ndim-1);
    for (i = 0; i < ndim; ++i) {
      tmp_axis = MH_HIST_AXIS(THIS, i);
      tmp = axis_to_hashref(aTHX_ MH_HIST_AXIS(THIS, i));
      av_store(axis_av, i, tmp);
    }

    if ( ! hv_stores(hash, "nfills", newSVuv(MH_HIST_NFILLS(THIS))) )
      croak("hv_stores nfills failed");
    if ( !hv_stores(hash, "total", newSVnv(MH_HIST_TOTAL(THIS))) )
      croak("hv_stores total failed");

    /* store data */
    /* FIXME: strictly speaking, this violates encapsulation */
    nbins_total = THIS->nbins_total;
    data_av = newAV();
    if ( ! hv_stores(hash, "data", newRV_noinc((SV *)data_av)) )
      croak("hv_stores data failed");

    av_extend(data_av, nbins_total-1);
    data = THIS->data;
    for (i = 0; i < nbins_total; ++i)
      av_store(data_av, i, newSVnv(data[i]));

    XPUSHs(rv);
    XSRETURN(1);
#line 1958 "Histogram.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Histogram__from_hash_internal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Histogram__from_hash_internal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "CLASS, hash, axises");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	HV *	hash;
	AV *	axises;
#line 413 "./XS/Histogram.xs"
    mh_axis_t **axis_structs;
    unsigned int i, n, ndim, nfill;
    double total_content;
    double *data;
    SV **svptr;
    AV *axis_av;
    AV *data_av;
#line 1984 "Histogram.c"
	mh_histogram_t *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    hash = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Math::Histogram::_from_hash_internal",
				"hash");
		}
	} STMT_END
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    axises = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Math::Histogram::_from_hash_internal",
				"axises");
		}
	} STMT_END
;
#line 421 "./XS/Histogram.xs"
    /* dimensionality */
    HV_FETCHS_FATAL(svptr, hash, "ndim");
    ndim = SvUV( *svptr );
    if (ndim < 1)
      croak("Need at least a dimension of 1");

    /* nfills and total */
    HV_FETCHS_FATAL(svptr, hash, "nfills");
    nfill = SvUV( *svptr );
    HV_FETCHS_FATAL(svptr, hash, "total");
    total_content = SvNV( *svptr );

    /* data array */
    HV_FETCHS_FATAL(svptr, hash, "data");
    DEREF_RV_TO_AV(data_av, *svptr);
    if (data_av == NULL)
      croak("'data' entry is not an array reference");

    /* axises */
    n = av_len(axises)+1;
    if (n != ndim)
      croak("Number of axises needs to be same as number of dimensions");

    axis_structs = av_to_axis_ary(aTHX_ axises, n);
    if (axis_structs == NULL)
      croak("Need array reference of axis objetcs");
    /* Mark the fresh axises as owned by the histogram */
    for (i = 0; i < n; ++i) {
      UV flags = PTR2UV(MH_AXIS_USERDATA(axis_structs[i]));
      flags |= F_AXIS_OWNED_BY_HIST;
      MH_AXIS_USERDATA(axis_structs[i]) = INT2PTR(void *, flags);
    }

    /* make output struct */
    RETVAL = mh_hist_create(ndim, axis_structs);
    RETVAL->nfills = nfill;
    RETVAL->total = total_content;

    /* fill data */
    n = RETVAL->nbins_total;
    if ((unsigned int)(av_len(data_av)+1) != n) {
      free(RETVAL);
      croak("Input data array length (%u) is not the same as the total number of bins in the histogram (%u)", av_len(data_av)+1, n);
    }
    data = RETVAL->data;
    for (i = 0; i < n; ++i) {
      svptr = av_fetch(data_av, i, 0);
      if (svptr == NULL) {
        free(RETVAL);
        croak("Failed to fetch scalar from array!?");
      }
      data[i] = SvNV(*svptr);
    }
#line 2068 "Histogram.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'Histogram.xs' from 'XS/Histogram.xs' */

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__Histogram); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Histogram)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::Histogram::Axis::new", XS_Math__Histogram__Axis_new);
        newXS_deffile("Math::Histogram::Axis::DESTROY", XS_Math__Histogram__Axis_DESTROY);
        newXS_deffile("Math::Histogram::Axis::_as_hash", XS_Math__Histogram__Axis__as_hash);
        newXS_deffile("Math::Histogram::Axis::_from_hash", XS_Math__Histogram__Axis__from_hash);
        newXS_deffile("Math::Histogram::Axis::clone", XS_Math__Histogram__Axis_clone);
        newXS_deffile("Math::Histogram::Axis::nbins", XS_Math__Histogram__Axis_nbins);
        newXS_deffile("Math::Histogram::Axis::min", XS_Math__Histogram__Axis_min);
        newXS_deffile("Math::Histogram::Axis::max", XS_Math__Histogram__Axis_max);
        newXS_deffile("Math::Histogram::Axis::width", XS_Math__Histogram__Axis_width);
        newXS_deffile("Math::Histogram::Axis::binsize", XS_Math__Histogram__Axis_binsize);
        newXS_deffile("Math::Histogram::Axis::lower_boundary", XS_Math__Histogram__Axis_lower_boundary);
        newXS_deffile("Math::Histogram::Axis::upper_boundary", XS_Math__Histogram__Axis_upper_boundary);
        newXS_deffile("Math::Histogram::Axis::bin_center", XS_Math__Histogram__Axis_bin_center);
        newXS_deffile("Math::Histogram::Axis::find_bin", XS_Math__Histogram__Axis_find_bin);
        newXS_deffile("Math::Histogram::new", XS_Math__Histogram_new);
        newXS_deffile("Math::Histogram::DESTROY", XS_Math__Histogram_DESTROY);
        newXS_deffile("Math::Histogram::clone", XS_Math__Histogram_clone);
        newXS_deffile("Math::Histogram::new_alike", XS_Math__Histogram_new_alike);
        newXS_deffile("Math::Histogram::get_axis", XS_Math__Histogram_get_axis);
        newXS_deffile("Math::Histogram::ndim", XS_Math__Histogram_ndim);
        newXS_deffile("Math::Histogram::nfills", XS_Math__Histogram_nfills);
        newXS_deffile("Math::Histogram::total", XS_Math__Histogram_total);
        newXS_deffile("Math::Histogram::find_bin_numbers", XS_Math__Histogram_find_bin_numbers);
        newXS_deffile("Math::Histogram::fill", XS_Math__Histogram_fill);
        newXS_deffile("Math::Histogram::fill_w", XS_Math__Histogram_fill_w);
        newXS_deffile("Math::Histogram::fill_n", XS_Math__Histogram_fill_n);
        newXS_deffile("Math::Histogram::fill_nw", XS_Math__Histogram_fill_nw);
        newXS_deffile("Math::Histogram::fill_bin", XS_Math__Histogram_fill_bin);
        newXS_deffile("Math::Histogram::fill_bin_w", XS_Math__Histogram_fill_bin_w);
        newXS_deffile("Math::Histogram::fill_bin_n", XS_Math__Histogram_fill_bin_n);
        newXS_deffile("Math::Histogram::fill_bin_nw", XS_Math__Histogram_fill_bin_nw);
        newXS_deffile("Math::Histogram::get_bin_content", XS_Math__Histogram_get_bin_content);
        newXS_deffile("Math::Histogram::set_bin_content", XS_Math__Histogram_set_bin_content);
        newXS_deffile("Math::Histogram::contract_dimension", XS_Math__Histogram_contract_dimension);
        newXS_deffile("Math::Histogram::cumulate", XS_Math__Histogram_cumulate);
        newXS_deffile("Math::Histogram::data_equal_to", XS_Math__Histogram_data_equal_to);
        newXS_deffile("Math::Histogram::is_overflow_bin", XS_Math__Histogram_is_overflow_bin);
        newXS_deffile("Math::Histogram::is_overflow_bin_linear", XS_Math__Histogram_is_overflow_bin_linear);
        newXS_deffile("Math::Histogram::_debug_bin_iter_print", XS_Math__Histogram__debug_bin_iter_print);
        newXS_deffile("Math::Histogram::_debug_dump_data", XS_Math__Histogram__debug_dump_data);
        newXS_deffile("Math::Histogram::_as_hash", XS_Math__Histogram__as_hash);
        newXS_deffile("Math::Histogram::_from_hash_internal", XS_Math__Histogram__from_hash_internal);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
